<?php
/*    
    eigT - Quebra-Cabecas de pecas deslizantes de 8 pecas.
    Copyright (C) 2004  tDs - tds-@brturbo.com
   
    Este programa  software livre; voc pode redistribu-lo e/ou
    modific-lo sob os termos da Licena Pblica Geral GNU, conforme
    publicada pela Free Software Foundation; tanto a verso 2 da
    Licena como (a seu critrio) qualquer verso mais nova.

    Este programa  distribudo na expectativa de ser til, mas SEM
    QUALQUER GARANTIA; sem mesmo a garantia implcita de
    COMERCIALIZAO ou de ADEQUAO A QUALQUER PROPSITO EM
    PARTICULAR. Consulte a Licena Pblica Geral GNU para obter mais
    detalhes.
 
    Voc deve ter recebido uma cpia da Licena Pblica Geral GNU
    junto com este programa; se no, escreva para a Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307, USA.

   +------------------------------------------------------------+
   + Funcoes graficas                                           +
   +------------------------------------------------------------+
   + file: graficos.inc.php                                     +
   +------------------------------------------------------------+
   + Algumas funcoes graficas, que nao se encontram na classe   +
   + cleeasy, foram implemtadas aqui.                           +
   +------------------------------------------------------------+
*/

class grafico  {
    
    function about ($cor)
    {
        $v = EIG_VERSAO;
        cleeasy::cores ($cor);
        cleeasy::echoxy (12,0, str_repeat ("-", 33));
        cleeasy::echoxy (13,0, "eigT $v - Quebra-Cabecas em php");
        cleeasy::echoxy (14,5, 'by tDs - tds-@brturbo.com');
        cleeasy::echoxy (15,0, str_repeat ("-", 33));
    }
    
    
    
    
    function tabuleiro ()
    {
        cleeasy::goto (0, 0);
        cleeasy::cores ('vermelho');
        
        $str =
                " __________________\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                "|                  |\n\r".
                '""""""""""""""""""""'."\n\r\033[0;0H";
        cleeasy::echoxy (0, 0, $str);
    }
    
    
    
    
    function coloca_peca ($posicao = 0, $valor = 0)
    {
        $v = $valor;
        cleeasy::cores ('ciano');
        
        switch ($posicao) {
            case (1):
                $str = 
                        "\033[2;2H".
                        "|''''|\033[3;2H".
                        "|  $v |\033[4;2H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (2):
                $str = 
                        "\033[2;8H".
                        "|''''|\033[3;8H".
                        "|  $v |\033[4;8H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (3):
                $str = 
                        "\033[2;14H".
                        "|''''|\033[3;14H".
                        "|  $v |\033[4;14H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (4):
                $str = 
                        "\033[5;2H".
                        "|''''|\033[6;2H".
                        "|  $v |\033[7;2H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (5):
                $str = 
                        "\033[5;8H".
                        "|''''|\033[6;8H".
                        "|  $v |\033[7;8H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (6):
                $str = 
                        "\033[5;14H".
                        "|''''|\033[6;14H".
                        "|  $v |\033[7;14H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (7):
                $str = 
                        "\033[8;2H".
                        "|''''|\033[9;2H".
                        "|  $v |\033[10;2H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (8):
                $str = 
                        "\033[8;8H".
                        "|''''|\033[9;8H".
                        "|  $v |\033[10;8H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
                
            case (9):
                $str = 
                        "\033[8;14H".
                        "|''''|\033[9;14H".
                        "|  $v |\033[10;14H".
                        "|____|";
                cleeasy::echo_ ($str);
                break;
        }
    }
    
    
    
    
    function exibir_posicoes ()
    {
        grafico::tabuleiro ();
        $posicoes = $_SESSION['EIG_posicoes'];
        $cont     = 1;
        foreach ($posicoes as $posicao) {
            if ($posicao === 0) continue;
            if ($posicao === EIG_VAZIO) {
                $cont++;
                continue;
            }
            grafico::coloca_peca ($cont, $posicao);
            $cont++;
        }
        cleeasy::goto (1000, 1000);
    }
    
    
    
    
    function informacoes ()
    {
        $movimentos = $_SESSION['EIG_movimentos']; // numero de jogadas  efetuadas ate o momento
        $corretas   = eigt::posicoes_corretas ();
        $tempo      = eigt::atualiza_tempo ();
        $jogadas    = $movimentos.' jogada.';
        
        cleeasy::cores ('amarelo');
        cleeasy::echoxy (12, 1, str_repeat ('*', 33) );
        cleeasy::echoxy (13, 1, "* $jogadas                   ");
        cleeasy::echoxy (14, 1, "* $corretas pecas estao corretas e  se ");
        cleeasy::echoxy (15, 1, "* passaram $tempo segundos.                         ");
        cleeasy::echoxy (16, 1, str_repeat ('*', 33) );
        cleeasy::echoxy (13, 33, '*');
        cleeasy::echoxy (14, 33, '*');
        cleeasy::echoxy (15, 33, '*');
    }
    
    
    
    
    function finalizar_eigt ()
    {
        $movimentos = $_SESSION['EIG_movimentos'];
        $corretas   = eigt::posicoes_corretas ();
        $tempo      = eigt::atualiza_tempo ();
        $posicao    = $_SESSION['EIG_posicoes'];
        $v          = $posicao[7];
        
        cleeasy::limpar_linha (23, 0, 5);
        grafico::tabuleiro ();
        
        for ($cont = 1; $cont <= 9; $cont++) {
            if ($posicao[$cont] == EIG_VAZIO) continue;
            grafico::coloca_peca ($cont, $posicao[$cont]);
        }
        
        cleeasy::cores('verde');
            
        for ($cont = 8; $cont < 20; $cont--) {
            $str =  "\033[$cont;2H".
                    "|''''|\033[". ++$cont .";2H".
                    "|  $v |\033[".++$cont .";2H"."|____|";
            cleeasy::echo_ ($str);
            cleeasy::goto (1000, 1000);
            usleep (100000);
            cleeasy::echoxy ($cont-2, 2, '      ');
            if ($cont == 13) {
                cleeasy::cores  ('vermelho');
                cleeasy::echoxy (11, 1,'""""""""""""""""""""');
                cleeasy::cores  ('verde');
            }
        }
        
        $pos = $cont - 1;
        cleeasy::echoxy ($pos, 2, "|''''|");
        cleeasy::echoxy ($pos+1, 6, '  ');
        cleeasy::typewriter (20, 4, 'Finalizado em ');
        cleeasy::updown (20, 18, "$movimentos jogadas em $tempo segundos. ", 0, 3);
        cleeasy::cores  ('branco');
    }
}
?>
